Bloggie.Web/Controllers/AdminBlogPostsController.cs
using Bloggie.Web.Models.Domains;
using Bloggie.Web.Models.ViewModels;
using Bloggie.Web.Repositories;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Bloggie.Web.Controllers
{
    [Authorize(Roles = "Admin")]
    public class AdminBlogPostsController : Controller
    {
        private readonly ITagRepository tagRepository;
        private readonly IBlogPostRepository blogPostRepository;

        public AdminBlogPostsController(ITagRepository tagRepository,IBlogPostRepository blogPostRepository)
        {
            this.tagRepository = tagRepository;
            this.blogPostRepository = blogPostRepository;
        }

        [HttpGet]
        public async Task< IActionResult> Add()
        {
            var tags = await tagRepository.GetAllAsync();
            var model = new AddBlogPostRequest
            {
                Tags = tags.Select(x => new SelectListItem { Text = x.DisplayName, Value = x.id.ToString() })
            };  
            return View(model);

        }
        [HttpPost]
        public async Task<IActionResult> Add(AddBlogPostRequest addBlogPostRequest) {

            var blogPost = new BlogPost
            {
                Heading = addBlogPostRequest.Heading,
                Title = addBlogPostRequest.Title,
                Content = addBlogPostRequest.Content,
                ShortDescription = addBlogPostRequest.ShortDescription,
                FeaturedImageUrl = addBlogPostRequest.FeaturedImageUrl,
                UrlHandle = addBlogPostRequest.UrlHandle,
                PublicshedDate = addBlogPostRequest.PublicshedDate,
                Author = addBlogPostRequest.Author,
                Visible = addBlogPostRequest.Visible,

            };
            //map tags
            var selectedTags=new List<Tag>();
            foreach(var selectedTagId in addBlogPostRequest.SelectedTags)
            {
                var selectedTagIdAsGuid=Guid.Parse(selectedTagId);
                var existingTag = await tagRepository.GetAsync(selectedTagIdAsGuid);

                if (existingTag != null)
                {
                    selectedTags.Add(existingTag);

                }
            }

            blogPost.Tags = selectedTags;



            await blogPostRepository.AddAsync(blogPost);
            return RedirectToAction("Add");
        }

        [HttpGet]
        public async Task<IActionResult>List()
        {
            var blogPosts= await blogPostRepository.GetAllAasync();
            return View(blogPosts);
        }

        [HttpGet]
        public async Task<IActionResult>Edit(Guid id)
        {
            //retrive result from the repository
          var blogPost=  await blogPostRepository.GetAsync(id);
            var tagsDomainModel= await tagRepository.GetAllAsync();

            if (blogPost != null)
            {


                //map the domain model intoa  the view model
                var model = new EditBlogPostRequest
                {
                    Id = blogPost.Id,
                    Heading = blogPost.Heading,
                    Title = blogPost.Title,
                    Content = blogPost.Content,
                    Author = blogPost.Author,
                    FeaturedImageUrl = blogPost.FeaturedImageUrl,
                    UrlHandle = blogPost.UrlHandle,
                    ShortDescription = blogPost.ShortDescription,
                    PublicshedDate = blogPost.PublicshedDate,
                    Visible = blogPost.Visible,
                    Tags = tagsDomainModel.Select(x => new SelectListItem
                    {
                        Text = x.Name,
                        Value = x.id.ToString()
                    }),
                    SelectedTags = blogPost.Tags.Select(x => x.id.ToString()).ToArray()
                };
                return View(model); 
            }
            // pass data to view 

            return View(null);
        }

        [HttpPost]
        public async Task<IActionResult>Edit(EditBlogPostRequest editBlogPostRequest)
        {
            // map view model back to domain model
            var blogPostDomainModel = new BlogPost
            {
                Id = editBlogPostRequest.Id,
                Heading = editBlogPostRequest.Heading,
                Title = editBlogPostRequest.Title,
                Content = editBlogPostRequest.Content,
                Author = editBlogPostRequest.Author,
                ShortDescription = editBlogPostRequest.ShortDescription,
                FeaturedImageUrl = editBlogPostRequest.FeaturedImageUrl,
                UrlHandle = editBlogPostRequest.UrlHandle,
                PublicshedDate = editBlogPostRequest.PublicshedDate,
                Visible = editBlogPostRequest.Visible,

            };

            //MAP tags into domain model

            var selectedTags = new List<Tag>();
            foreach(var selectedTag in editBlogPostRequest.SelectedTags)
            {
                if(Guid.TryParse(selectedTag,out var tag))
                {
                    var foundTag =await tagRepository.GetAsync(tag);

                    if(foundTag != null)
                    {
                        selectedTags.Add(foundTag);
                    }
                }

            }

            blogPostDomainModel.Tags= selectedTags;

            //submit information to repository to update
           var updatedBlog= await blogPostRepository.UpdateAsync(blogPostDomainModel);

            if(updatedBlog != null)
            {
                //show sucssess not
                return RedirectToAction("Edit");
            }

            //redirect to get 
            return RedirectToAction("Edit");

        }
        [HttpPost]
        public async Task<IActionResult>Delete(EditBlogPostRequest editBlogPostRequest)
        {
            //talk to repository to delete this blog post and tags
           var deletedBlogPost = await blogPostRepository.DeleteAsync(editBlogPostRequest.Id);
            if (deletedBlogPost != null)
            {
                return RedirectToAction("List");
            }

            return RedirectToAction("Edit", new {id = editBlogPostRequest.Id});

            //display the response
        }

    }
}

Bloggie.Web/Controllers/AdminTagsController.cs
using Azure;
using Bloggie.Web.Data;
using Bloggie.Web.Models.Domains;
using Bloggie.Web.Models.ViewModels;
using Bloggie.Web.Repositories;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace Bloggie.Web.Controllers
{
    [Authorize(Roles = "Admin")]
    public class AdminTagsController : Controller


    {
        private readonly BloggyDbContext bloggyDbContext;
        private readonly ITagRepository tagRepository;

        public AdminTagsController(ITagRepository tagRepository)
        {
            this.tagRepository = tagRepository;
        }

        [HttpGet]
        public IActionResult Add()
        {
            return View();
        }
        [HttpPost]
        [ActionName("Add")]
        public async Task<IActionResult> Add(AddTagRequest addTagRequest)
        {
            ValidateAddTagRequest(addTagRequest);
            if (ModelState.IsValid==false)
            {
                return View();
            }
            var tag = new Tag
            {
                Name = addTagRequest.Name,
                DisplayName = addTagRequest.DisplayName
            };


            await tagRepository.AddAsync(tag);
            return RedirectToAction("List");
        }

        [HttpGet]
        [ActionName("List")]
        public async Task<IActionResult> List()
        {
            var tags = await tagRepository.GetAllAsync();

            return View(tags);
        }
        [HttpGet]
        public async Task<IActionResult> Edit(Guid id)
        {

           var tag= await tagRepository.GetAsync(id);
            if (tag != null)
            {
                var editTagRequest = new EditTagRequest
                {
                    Id = id,
                    Name = tag.Name,
                    DisplayName = tag.DisplayName

                };
                return View(editTagRequest);
            }

            return View(null);

        }
        [HttpPost]
        public async Task<IActionResult> Edit(EditTagRequest editTagRequest)
        {
            var tag = new Tag
            {
                id = editTagRequest.Id,
                Name = editTagRequest.Name,
                DisplayName = editTagRequest.DisplayName
            };

            var updateTag = await tagRepository.UpdateAsync(tag);
            if (updateTag != null)
            {
                //show sucsess notification
            }
            else
            {
                //show fail
            }
            return RedirectToAction("Edit", new { id = editTagRequest.Id });

        }
        [HttpPost]
        public async Task<IActionResult> Delete(EditTagRequest editTagRequest)
        {

           var deletedTag =  await tagRepository.DeleteAsync(editTagRequest.Id);
            if (deletedTag != null)
            {
                //show succes notificayion
                return RedirectToAction("List");
            }
            
                //fail notification
            
            return RedirectToAction("Edit", new { id = editTagRequest.Id });
        }
        private void ValidateAddTagRequest(AddTagRequest request)
        {
            if(request.Name is not null && request.DisplayName is not null)
            {
                if (request.Name == request.DisplayName)
                {
                    ModelState.AddModelError
                        ("DisplayName", "Name cannot be the same as DisplayName");
                }
            }
        }
    }
}

Bloggie.Web/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Identity
@inject SignInManager<IdentityUser> signInManager

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Bloggie.Web</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/Bloggie.Web.styles.css" asp-append-version="true" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">

    <link href='https://cdn.jsdelivr.net/npm/froala-editor@latest/css/froala_editor.pkgd.min.css' rel='stylesheet' type='text/css' />

    <script type='text/javascript' src='https://cdn.jsdelivr.net/npm/froala-editor@latest/js/froala_editor.pkgd.min.js'></script>
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark bg-dark border-bottom box-shadow ">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Bloggie.Web</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>

                        @if (signInManager.IsSignedIn(User) && User.IsInRole("Admin"))
                        {
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    Admin
                                </a>
                                <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    <li>
                                        <a class="dropdown-item"
                                           asp-area=""
                                           asp-controller="AdminTags"
                                           asp-action="Add">Add Tag</a>
                                    </li>

                                    <li>
                                        <a class="dropdown-item"
                                           asp-area=""
                                           asp-controller="AdminTags"
                                           asp-action="List">Show All Tag</a>
                                    </li>

                                    <li>
                                        <a class="dropdown-item"
                                           asp-area=""
                                           asp-controller="AdminBlogPosts"
                                           asp-action="Add">Add Blog Post</a>
                                    </li>

                                    <li>
                                        <a class="dropdown-item"
                                           asp-area=""
                                           asp-controller="AdminBlogPosts"
                                           asp-action="List">
                                            All BlogPosts
                                        </a>
                                    </li>
                                    <li>
                                        <a class="dropdown-item"
                                           asp-area=""
                                           asp-controller="AdminUsers"
                                           asp-action="List">
                                            All Users
                                        </a>
                                    </li>



                                </ul>
                            </li>
                        }




                    </ul>
                    <div class="d-flex align-items-center">
                        @if (signInManager.IsSignedIn(User))
                        {
                            <div class="me-3 text-light">
                                @User?.Identity?.Name
                            </div>

                            <a class=" btn me-3 bg-light text-dark"
                               asp-area=""
                               asp-controller="Account"
                               asp-action="Logout">Logout</a>

                        }

                        else
                        {
                            <a class=" btn me-3 bg-light text-dark"
                               asp-area=""
                               asp-controller="Account"
                               asp-action="Login">Login</a>


                            <a class=" btn me-3 bg-light text-dark"
                               asp-area=""
                               asp-controller="Account"
                               asp-action="Register">Register</a>

                        }

                    </div>
                </div>
            </div>
        </nav>
    </header>
    <div>
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - Bloggie.Web - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>